<?php

class d4p_sa_method_rendered extends WP_Widget {
    var $id;
    var $defaults = array(
        'title' => 'Last month posts',
        'cache' => 30
    );

    public function __construct($id_base = false, $name = "", $widget_options = array(), $control_options = array()) {
        parent::__construct("d4p-sa-rendered", "D4P Smashing Authors: Rendered", array("description" => "Previous month top author posts."));
    }

    public function widget($args, $instance) {
        extract($args, EXTR_SKIP);

        $this->id = $widget_id;

        echo $before_widget;
            echo $before_title;
                echo $instance['title'];
            echo $after_title;
            echo $this->render($instance);
        echo $after_widget;
    }

    function form($instance) {
        $instance = wp_parse_args((array)$instance, $this->defaults);

        ?>

        <p><label>Title:</label>
            <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $instance['title']; ?>" />
        </p>
        <p><label>Days to store in cache:</label>
            <input class="widefat" id="<?php echo $this->get_field_id('cache'); ?>" name="<?php echo $this->get_field_name('cache'); ?>" type="text" value="<?php echo $instance['cache']; ?>" />
        </p>
        
        <?php
    }

    function update($new_instance, $old_instance) {
        $instance = $old_instance;

        $instance["title"] = strip_tags(stripslashes($new_instance["title"]));
        $instance["cache"] = intval(strip_tags(stripslashes($new_instance["cache"])));

        return $instance;
    }

    public function get_data($instance) {
        $data = $this->get_real_data($instance);

        foreach ($data as $post) {
            wp_cache_add($post->ID, $post, 'posts');
        }

        return $data;
    }

    public function get_real_data($instance) {
        global $wpdb;

        $sql = "select p.*, u.display_name, u.user_url, u.user_email, u.user_nicename
                from $wpdb->posts p
                inner join $wpdb->users u on u.ID = p.post_author
                inner join (select post_author as author, count(*) as posts 
                            from $wpdb->posts 
                            where post_type = 'post' 
                            and post_status = 'publish' 
                            and month(post_date) = month(now()) - 1
                            group by post_author 
                            order by count(*) desc
                            limit 0, 5) l on l.author = p.post_author
                where p.post_type = 'post' 
                and p.post_status = 'publish'
                and month(p.post_date) = month(now()) - 1
                order by l.posts asc
                limit 0, 20";
        return $wpdb->get_results($sql);
    }

    public function render($instance) {
        $rendered = get_transient('widget_'.$this->id);

        if ($rendered === false) {
            $data = $this->get_data($instance);

            $rendered = '<ul>';
            foreach ($data as $post) {
                $rendered.= '<li>';
                $rendered.= '<a href="'.get_permalink($post->ID).'">'.$post->post_title.'</a> by ';
                $rendered.= '<a href="'.get_author_posts_url($post->post_author, $post->user_nicename).'">'.$post->display_name.'</a>';
                $rendered.= '</li>';
            }
            $rendered.= '</ul>';

            set_transient('widget_'.$this->id, $rendered, $instance['cache'] * 3600 * 24);
        }

        echo $rendered;
    }
}

?>